
//Example 2
//passing functions pointers as parameters to another //function.

#include <stdio.h>

void Square (int*,int*);
void Cube (int*, int*);
void Swap (int*, int*);

typedef void(*VPF)(int*, int*);
void PrintVals( VPF, int*, int*);
//without typedef:
//void PrintVals( void (*)(int*, int*), int*, int*);

//----------------------------------------------------------------

int main()
{
	int valOne=1, valTwo=2;
	void (*pFunc)(int*, int*);
	pFunc = Square;



	//calling PrintVals with some pointer pointing at //some function:
	PrintVals ( pFunc, &valOne, &valTwo );
		
	//calling PrintVals with swap:
	PrintVals ( Swap, &valOne, &valTwo );

	return 0;
}
//----------------------------------------------------------------

void PrintVals( VPF pFunc, int* x, int* y)
{
	printf("before executing passed function:\n x: %d  y: %d\n", *x ,*y);
	pFunc(x, y);
	printf("after  executing passed function:\n x: %d  y: %d\n", *x ,*y);
}
//----------------------------------------------------------------

void Square (int* px,int* py)
{
	*px =  (*px)*(*px);
	*py =  (*py)*(*py);
}
//----------------------------------------------------------------

void Cube (int* px, int* py)
{
	*px = (*px)*(*px)*(*px);
	*py = (*py)*(*py)*(*py);

}
//----------------------------------------------------------------
void Swap (int* px, int* py)
{
	int temp = *px;
	*px = *py;
	*py = temp;
}
//----------------------------------------------------------------
